// MT Engine MK2
// Copyleft 2014 the Mojon Twins

// enems.h
// Enemy management, new style

// Ninjajar Clouds not supported, sorry!
// Type 5 "random respawn not supported sorry! (but easily punchable!)

// There are new, more suitable defines now.
// ENABLE_FLYING_ENEMIES
// ENABLE_LINEAR_ENEMIES
// ENABLE_PURSUE_ENEMIES
// ENABLE_SHOOTERS

#if defined (ENABLE_FLYING_ENEMIES) || defined (ENABLE_SHOOTERS)
unsigned char distance (unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2) {
	unsigned char dx = abs (x2 - x1);
	unsigned char dy = abs (y2 - y1);
	unsigned char mn = dx < dy ? dx : dy;
	return (dx + dy - (mn >> 1) - (mn >> 2) + (mn >> 4));
}
#endif

#ifdef ENABLE_SHOOTERS
unsigned char coco_x [MAX_COCOS], coco_y [MAX_COCOS], coco_s [MAX_COCOS], ctx, cty;
signed char coco_vx [MAX_COCOS], coco_vy [MAX_COCOS];
void __FASTCALL__ init_cocos (void) {
	for (gpit = 0; gpit < MAX_COCOS;) coco_s [gpit++] = 0;
}

unsigned char coco_it, coco_d, coco_x0;
void __FASTCALL__ shoot_coco (void) {
	coco_x0 = gpen_cx + 4;
#ifdef TYPE_8_FIRE_ONE
	coco_it = gpit;
	{
#else	
	for (coco_it = 0; coco_it < MAX_COCOS; coco_it ++) {
#endif
		if (coco_s [coco_it] == 0) {
			coco_d = distance (coco_x0, gpen_cy, gpx, gpy);
			if (coco_d >= TYPE_8_SAFE_DISTANCE) {
#ifdef MODE_128K
				wyz_play_sound (3);
#endif
				coco_s [coco_it] = 1;
				coco_x [coco_it] = coco_x0;
				coco_y [coco_it] = gpen_cy;	

				coco_vx [coco_it] = (COCO_SPEED_8 * (gpx - coco_x0) / coco_d);
				coco_vy [coco_it] = (COCO_SPEED_8 * (gpy - gpen_cy) / coco_d);
			}
		}		
	}
}

void __FASTCALL__ move_cocos (void) {
	for (coco_it = 0; coco_it < MAX_COCOS; coco_it ++) {
		if (coco_s [coco_it]) {
			coco_x [coco_it] += coco_vx [coco_it];
			coco_y [coco_it] += coco_vy [coco_it];
			
			if (coco_x [coco_it] >= 240 || coco_y [coco_it] >= 160) coco_s [coco_it] = 0;
			// Collide player
			ctx = coco_x [coco_it] + 3;
			cty = coco_y [coco_it] + 3;
			if (p_estado == EST_NORMAL) {
				if (collide_pixel (ctx, cty, gpx, gpy)) {
					coco_s [coco_it] = 0;
#ifdef MODE_128K
						kill_player (7);
#else
						kill_player (4);
#endif		
				}		
			}
		}
	}
}
#endif

// Type 5 "random respawn" is not supported by default (after all, it was
// something made for Zombie Calavera which has been never used later, so...
// Anyways, I will leave this here in case you want to reimplement them
// (or something simmilar). This snipped may come handy!
/*
#ifdef ENABLE_RANDOM_RESPAWN
char player_hidden (void) {
	gpxx = gpx >> 4;
	gpyy = gpy >> 4;
	if ( (gpy & 15) == 0 && p_vx == 0 ) {
		if (attr (gpxx, gpyy) == 2 || (attr (1 + gpxx, gpyy) == 2 && (gpx & 15)) ) {
			return 1;
		}
	}
	return 0;
}
#endif
*/

#ifdef WALLS_STOP_ENEMIES
unsigned char gpa1, gpa2, gpa3;
unsigned char __FASTCALL__ mons_col_sc_x (unsigned char solid) {
	if (solid) return 0;
	gpa1 = gpen_cy >> 4;
	gpa2 = (pen_cy + 15) >> 4;
	gpa3 = (gpen_cx >> 4) + (malotes [enoffsmasi].mx > 0);
#ifdef EVERYTHING_IS_A_WALL
	return (attr (gpa3, gpa1) || attr (gpa3, gpa2);	
#else
	return ((attr (gpa3, gpa1) & 8) || (attr (gpa3, gpa2) & 8));
#endif
}

unsigned char __FASTCALL__ mons_col_sc_y (unsigned char solid) {
	if (solid) return 0;
	gpa1 = gpen_cx >> 4;
	gpa2 = (gpen_cx + 15) >> 4;
	gpa3 = (gpen_cy >> 4) + (malotes [enoffsmasi].my > 0);
#ifdef EVERYTHING_IS_A_WALL
	return (attr (gpa1, gpa3) || attr (gpa2, gpa3));
#else
	return ((attr (gpa1, gpa3) & 8) || (attr (gpa2, gpa3) & 8));
#endif
}
#endif

#if defined(SLOW_DRAIN) && defined(PLAYER_BOUNCES)
unsigned char lasttimehit;
#endif

#if defined(ENABLE_FLYING_ENEMIES) || defined(ENABLE_RANDOM_RESPAWN)
int limit (int val, int min, int max) {
	if (val < min) return min;
	if (val > max) return max;
	return val;
}
#endif

unsigned char pregotten;
#ifdef ENABLE_SHOOTERS
unsigned char enemy_shoots;
#endif
unsigned char gptm;

//  Cebolla !!
void mueve_bicharracos (void) {
	gpx = p_x >> 6;
	gpy = p_y >> 6;
#ifndef PLAYER_MOGGY_STYLE	
	p_gotten = 0;
	ptgmx = 0;
	ptgmy = 0;
#endif

	tocado = 0;
	p_gotten = 0;
	for (gpit = 0; gpit < 3; gpit ++) {
		active = 0;
		enoffsmasi = enoffs + gpit;
		gpen_x = malotes [enoffsmasi].x;
		gpen_y = malotes [enoffsmasi].y;
		gpt = malotes [enoffsmasi].t;
		
		// Move
		switch (gptm = ((gpt >> 2) & 3)) {
			case 0:
				break;
#ifdef ENABLE_LINEAR_ENEMIES
			case 1:
				// Linear movement
				active = 1;
				malotes [enoffsmasi].x += malotes [enoffsmasi].mx;
				malotes [enoffsmasi].y += malotes [enoffsmasi].my;
				gpen_cx = malotes [enoffsmasi].x;
				gpen_cy = malotes [enoffsmasi].y;
				
#ifdef WALLS_STOP_ENEMIES
				if (gpen_cx == malotes [enoffsmasi].x1 || gpen_cx == malotes [enoffsmasi].x2 || mons_col_sc_x (gpt & 32))
					malotes [enoffsmasi].mx = -malotes [enoffsmasi].mx;
				if (gpen_cy == malotes [enoffsmasi].y1 || gpen_cy == malotes [enoffsmasi].y2 || mons_col_sc_y (gpt & 32))
					malotes [enoffsmasi].my = -malotes [enoffsmasi].my;
#else
				if (gpen_cx == malotes [enoffsmasi].x1 || gpen_cx == malotes [enoffsmasi].x2)
					malotes [enoffsmasi].mx = -malotes [enoffsmasi].mx;
				if (gpen_cy == malotes [enoffsmasi].y1 || gpen_cy == malotes [enoffsmasi].y2)
					malotes [enoffsmasi].my = -malotes [enoffsmasi].my;
#endif				
				break;
#endif
#ifdef ENABLE_FLYING_ENEMIES
			case 2:
				// Flying movement
				active = 1;
				gpen_cx = en_an_x [gpit] >> 6;
				gpen_cy = en_an_y [gpit] >> 6;
				switch (en_an_state [gpit]) {
					case TYPE_6_IDLE:
						if (distance (gpx, gpy, gpen_cx, gpen_cy) <= SIGHT_DISTANCE)
							en_an_state [gpit] = TYPE_6_PURSUING;
						break;
					case TYPE_6_PURSUING:
						if (distance (gpx, gpy, gpen_cx, gpen_cy) > SIGHT_DISTANCE) {
							en_an_state [gpit] = TYPE_6_RETREATING;
						} else {
							en_an_vx [gpit] = limit (
								en_an_vx [gpit] + addsign (p_x - en_an_x [gpit], FANTY_A),
								-FANTY_MAX_V, FANTY_MAX_V);
							en_an_vy [gpit] = limit (
								en_an_vy [gpit] + addsign (p_y - en_an_y [gpit], FANTY_A),
								-FANTY_MAX_V, FANTY_MAX_V);

							en_an_x [gpit] = limit (en_an_x [gpit] + en_an_vx [gpit], 0, 14336);
							en_an_y [gpit] = limit (en_an_y [gpit] + en_an_vy [gpit], 0, 9216);
						}
						break;
					case TYPE_6_RETREATING:
						en_an_x [gpit] += addsign (malotes [enoffsmasi].x - gpen_cx, 64);
						en_an_y [gpit] += addsign (malotes [enoffsmasi].y - gpen_cy, 64);

						if (distance (gpx, gpy, gpen_cx, gpen_cy) <= SIGHT_DISTANCE)
							en_an_state [gpit] = TYPE_6_PURSUING;
						break;
				}
				gpen_cx = en_an_x [gpit] >> 6;
				gpen_cy = en_an_y [gpit] >> 6;
				if (en_an_state [gpit] == TYPE_6_RETREATING &&
					gpen_cx == malotes [enoffsmasi].x &&
					gpen_cy == malotes [enoffsmasi].y
					)
					en_an_state [gpit] = TYPE_6_IDLE;
				break;
#endif
#ifdef ENABLE_PURSUE_ENEMIES
			case 3:
				// Linear pursuing movement
				active = 1;
				switch (en_an_alive [gpit]) {
					case 0:
						if (en_an_dead_row [gpit] == 0) {
							malotes [enoffsmasi].x = malotes [enoffsmasi].x1;
							malotes [enoffsmasi].y = malotes [enoffsmasi].y1;
							en_an_alive [gpit] = 1;
							en_an_rawv [gpit] = 1 << (rand () % 5);
							if (en_an_rawv [gpit] > 4) en_an_rawv [gpit] = 2;
							en_an_dead_row [gpit] = 11 + (rand () & 7);
#if defined(PLAYER_KILLS_ENEMIES) || defined(PLAYER_CAN_FIRE)
							malotes [enoffsmasi].life = ENEMIES_LIFE_GAUGE;
#endif
						} else {
							en_an_dead_row [gpit] --;
						}
						break;
					case 1:
						if (en_an_dead_row [gpit] == 0) {
#ifdef TYPE_7_FIXED_SPRITE
							en_an_base_frame [gpit] = (TYPE_7_FIXED_SPRITE - 1) << 1;
#else
							en_an_base_frame [gpit] = (rand () & 3) << 1;
#endif
							en_an_alive [gpit] = 2;
						} else {
							en_an_dead_row [gpit] --;
							en_an_next_frame [gpit] = sprite_17_a;
						}
						break;
					case 2:
						active = 1;
						if (p_estado == EST_NORMAL) {
							malotes [enoffsmasi].mx = (signed char) (addsign (((gpx >> 2) << 2) - gpen_x, en_an_rawv [gpit]));
							malotes [enoffsmasi].x += malotes [enoffsmasi].mx;
							gpen_xx = malotes [enoffsmasi].x >> 4;
							gpen_yy = malotes [enoffsmasi].y >> 4;
#ifdef WALLS_STOP_ENEMIES
							if (mons_col_sc_x ()) malotes [enoffsmasi].x = gpen_x;
#endif
							malotes [enoffsmasi].my = (signed char) (addsign (((gpy >> 2) << 2) - gpen_y, en_an_rawv [gpit]));
							malotes [enoffsmasi].y += malotes [enoffsmasi].my;
							gpen_xx = malotes [enoffsmasi].x >> 4;
							gpen_yy = malotes [enoffsmasi].y >> 4;
#ifdef WALLS_STOP_ENEMIES
							if (mons_col_sc_y ()) malotes [enoffsmasi].y = gpen_y;
#endif
						}
						gpen_cx = malotes [enoffsmasi].x;
						gpen_cy = malotes [enoffsmasi].y;
				}
				break;
#endif
		}
		
		// Next enemy if there's nothign to do with this one
		if (!active) continue;
		
		// Animate
		en_an_count [gpit] ++;
#ifdef ENABLE_CUSTOM_TYPE_6
		if (gptm != 2) {
#endif
			if (en_an_count [gpit] == 4) {
				en_an_count [gpit] = 0;
				en_an_frame [gpit] = !en_an_frame [gpit];
				en_an_next_frame [gpit] = enem_frames [en_an_base_frame [gpit] + en_an_frame [gpit]];
			}
#ifdef ENABLE_FLYING_ENEMIES 
		} else {
			en_an_next_frame [gpit] = enem_frames [en_an_base_frame [gpit] + (en_an_vx [gpit] > 0)];
		}
#endif
		
		// Fire coco?
#ifdef ENABLE_SHOOTERS
		if ((gpt & 16) && (rand () & TYPE_8_SHOOT_FREQ) == 1) {					
			shoot_coco ();
		}
#endif
		
		// Collide -> player
		// Special case: moving platform. t == 128 + 4 = 132, all flags ignored.
		// Note that these happen to be a "sprite 0 linear enemy".
#if !defined (PLAYER_MOGGY_STYLE) && !defined (DISABLE_PLATFORMS)	
		if (gpt == 132) {
			if (pregotten && (p_gotten == 0) && (p_saltando == 0)) {
				// Horizontal moving platforms
				if (malotes [enoffsmasi].mx) {
					if (gpy + 16 >= malotes [enoffsmasi].y && gpy + 10 <= malotes [enoffsmasi].y) {
						p_gotten = 1;
						ptgmx = malotes [enoffsmasi].mx << 6;
						p_y = (malotes [enoffsmasi].y - 16) << 6; gpy = p_y >> 6;
					}
				}
				
				// Vertical moving platforms
				if (
					(malotes [enoffsmasi].my < 0 && gpy + 18 >= malotes [enoffsmasi].y && gpy + 10 <= malotes [enoffsmasi].y) ||
					(malotes [enoffsmasi].my > 0 && gpy + 17 + malotes [enoffsmasi].my >= malotes [enoffsmasi].y && gpy + 10 <= malotes [enoffsmasi].y)
				) {
					p_gotten = 1;
					ptgmy = malotes [enoffsmasi].my << 6;
					p_y = (malotes [enoffsmasi].y - 16) << 6; gpy = p_y >> 6;
					p_vy = 0;
				}
			}
		} else if ((tocado == 0) && collide (gpx, gpy, gpen_cx, gpen_cy) && p_estado == EST_NORMAL) {
#else
		if ((tocado == 0) && collide (gpx, gpy, gpen_cx, gpen_cy) && p_estado == EST_NORMAL) {		
#endif	
#ifdef PLAYER_KILLS_ENEMIES
				// Step over enemy
#ifdef PLAYER_CAN_KILL_FLAG
				if (flags [PLAYER_CAN_KILL_FLAG] != 0 &&
					gpy < gpen_cy - 2 && p_vy >= 0 && malotes [enoffsmasi].t >= PLAYER_MIN_KILLABLE) {
#else				
				if (gpy < gpen_cy - 2 && p_vy >= 0 && malotes [enoffsmasi].t >= PLAYER_MIN_KILLABLE) {
#endif					
					en_an_next_frame [gpit] = sprite_17_a;					
#ifdef MODE_128K
					wyz_play_sound (6);
					en_an_state [gpit] = GENERAL_DYING;
					en_an_count [gpit] = 8;
#else					
					sp_MoveSprAbs (sp_moviles [gpit], spritesClip, en_an_next_frame [gpit] - en_an_current_frame [gpit], VIEWPORT_Y + (gpen_cy >> 3), VIEWPORT_X + (gpen_cx >> 3), gpen_cx & 7, gpen_cy & 7);
					en_an_current_frame [gpit] = en_an_next_frame [gpit];
					sp_UpdateNow ();
					peta_el_beeper (5);
					en_an_next_frame [gpit] = sprite_18_a;
#endif					
					malotes [enoffsmasi].t |= 16;			// Mark as dead				
					p_killed ++;
#ifdef ACTIVATE_SCRIPTING
#ifdef EXTENDED_LEVELS
					if (level_data->activate_scripting) {
#endif
						// Run this screen fire script or "entering any".
						run_script (n_pant + n_pant + 1);
						run_script (2 * MAP_W * MAP_H + 1);
#ifdef EXTENDED_LEVELS
					}
#endif						
#endif
				} else {
#else
				{
#endif
					tocado = 1;
					
#ifdef ENABLE_PUSHERS
					if (0 == (gpt & 64)) {
#endif						
#if defined(SLOW_DRAIN) && defined(PLAYER_BOUNCES)
						if ((lasttimehit == 0) || ((maincounter & 3) == 0)) {
#ifdef MODE_128K
							kill_player (7);
#else
							kill_player (4);
#endif
						}
#else
#ifdef MODE_128K
						kill_player (7);
#else
						kill_player (4);
#endif
#endif
#ifdef ENABLE_PUSHERS
					} else {
						// Enemy pushes you code.	
					}
#endif

#ifdef TYPE_6_KILL_ON_TOUCH
					if (gpt == 6) {
						en_an_next_frame [gpit] = sprite_18_a;
						malotes [enoffsmasi].t |= 16;
					}
#endif

#ifdef PLAYER_BOUNCES
#ifndef PLAYER_MOGGY_STYLE
					p_vx = addsign (malotes [enoffsmasi].mx, PLAYER_MAX_VX);
					p_vy = addsign (malotes [enoffsmasi].my, PLAYER_MAX_VX);
#else
					if (malotes [enoffsmasi].mx) {
						p_vx = addsign (gpx - gpen_cx, abs (malotes [enoffsmasi].mx) << 8);
					}
					if (malotes [enoffsmasi].my) {
						p_vy = addsign (gpy - gpen_cy, abs (malotes [enoffsmasi].my) << 8);
					}
#endif
#endif
				}
			}	
		}
		
		// Collide -> bullet
		
		// Collide -> hitter
	}
#if defined(SLOW_DRAIN) && defined(PLAYER_BOUNCES)
	lasttimehit = tocado;
#endif
}
